import java.awt.Point;
import java.io.IOException;
import java.util.ArrayList;

public class Matchfield {
	// x y
	public int[][] field;
	//ArrayList<Ship> shipList = new ArrayList<Ship>();
	public static final int SHIPCHAR = (int) 'S';
	public static final int WATERCHAR = (int) 'W';
	public static final int HITCHAR = (int) 'H';
	
	public Matchfield(Point size) {
		field = new int[size.x][size.y];
		for (int x = 0; x < size.x; x++) {
			for (int y = 0; y < size.y; y++) {
				field[x][y] = 0;
			}
		}

	}

	public boolean setShip(int startPosX, int startPosY, int len, char a) {
		try {
			if (a == 'h') { //Wenn horinzontales Schiff
				for (int i = startPosX; i < startPosX + len; i++) {
					if (field[i][startPosY] != 0) //Wenn Schiff ber Spielfeld hinaus geht
						return false;
					if (shipAbreast(i, startPosY))
						return false;
				}
				for (int i = startPosX; i < startPosX + len; i++) {
					field[i][startPosY] = SHIPCHAR;
				}
			} else { //Wenn vertikales Schiff
				for (int i = startPosY; i < startPosY + len; i++) {
					if (MainClass.myField.field[startPosX][i] != 0) //Wenn Schiff ber Spielfeld hinaus geht
						return false;
					if (shipAbreast(startPosX, i))
						return false;
				}
				for (int i = startPosY; i < startPosY + len; i++) {
					field[startPosX][i] = SHIPCHAR;
				}
			}

		} catch (Exception ex) {
			System.err.println(ex.toString());
			return false;
		}
		return true;
	}
	
	public boolean checkLose() {
		for (int x = 0; x < field.length; x++) {
			for (int y = 0; y < field[0].length; y++) {
				if (field[x][y] == SHIPCHAR) {
					return false;
				}
			}
		}
		System.out.println("Du hast Verloren!");
		return true;

	}

	private boolean shipAbreast(int x, int y) { //Schiffe nebeneinenader
		for (int a = x - 1; a <= x + 1; a++) {
			for (int b = y - 1; b <= y + 1; b++) {
				try {
					if (field[a][b] == SHIPCHAR) {
						return true;
					}
				} catch (IndexOutOfBoundsException ex) {
					//System.out.println(ex.toString());
				}
				catch (Exception ex) {
					System.err.println(ex.toString());
				}
			}
		}
		return false;
	}
	
	public boolean checkHit(Point p) { //Gebe zurck ob auf meinem Feld getroffen
		if (field[p.x][p.y] > 0) {
			return true;
		} else {
			return false;
		}
	}
	
	public void setHitOrWater(int c, Point p) {
		field[p.x][p.y] = c;
	}
	
	
	public void printArray() {
		try {
			for (int y = 0; y <= field[0].length; y++) {
				System.out.print("+-");
			}
			System.out.println("+");
			System.out.print("| ");
			for (int y = 0; y < field[0].length; y++) {
				System.out.print("|" + (char) (y + 65));
			}
			System.out.println("|");
			
			for (int x = 0; x < field.length; x++) {
				for (int y = 0; y <= field[0].length; y++) {
					System.out.print("+-");
				}
				System.out.println("+");
				System.out.print("|" + (x + 1));
				for (int y = 0; y < field[0].length; y++) {
					System.out.print("|" + (char) field[y][x]);
				}
				System.out.println("|");
			}
			for (int y = 0; y <= field[0].length; y++) {
				System.out.print("+-");
			}
			System.out.println("+");
			
			
		} catch(Exception e) {}
	}
}
